
x = 0;      // center of the apple
y = 0;
z = 0;
r = 1.0;    // radius of the apple
t = Pi/30;  // pencil size (measured in degrees on the apple surface)
lc = 0.1;   // characteristic element size
L  = 0.5;   // length of the pencil penetration length (less than 2*r)


p1 = newp; Point(p1) = {x,  y,  z,  lc} ;
// p2 = newp; Point(p2) = {x+r,y,  z,  lc} ;
p3 = newp; Point(p3) = {x,  y+r,z,  lc} ;
p4 = newp; Point(p4) = {x,  y,  z+r,lc} ;
p5 = newp; Point(p5) = {x-r,y,  z,  lc} ;
p6 = newp; Point(p6) = {x,  y-r,z,  lc} ;
p7 = newp; Point(p7) = {x,  y,  z-r,lc} ;
p8 = newp; Point(p8)   = {r*Cos(t)+x,   r*Sin(t)+y,  z  ,lc} ;
p9 = newp; Point(p9)   = {r*Cos(t)+x,  -r*Sin(t)+y,  z  ,lc} ;
p10 = newp; Point(p10) = {r*Cos(t)+x,  y,  r*Sin(t)+z   ,lc} ;
p11 = newp; Point(p11) = {r*Cos(t)+x,  y, -r*Sin(t)+z   ,lc} ;
p12 = newp; Point(p12) = {r*Cos(t)+x,  y, z, lc};

// make the organically shaped top of the apple by B-spline functions
cp1[0] = p3;
cp1[1] = newp; Point(cp1[1]) = {0,1.0,0.2, lc};
cp1[2] = newp; Point(cp1[2]) = {0, .9,0.45, lc};
cp1[3] = newp; Point(cp1[3]) = {0, .8,0.7, lc};
cp1[4] = newp; Point(cp1[4]) = {0, .7,0.8, lc};
cp1[5] = newp; Point(cp1[5]) = {0, .5,0.95, lc};
cp1[6] = newp; Point(cp1[6]) = {0, .2,1.15, lc};
cp1[7] = p4;

cp2[0] = p5;
cp2[1] = newp; Point(cp2[1]) = {-1.0,0,0.2, lc};
cp2[2] = newp; Point(cp2[2]) = {- .9,0,0.45, lc};
cp2[3] = newp; Point(cp2[3]) = {- .8,0,0.7, lc};
cp2[4] = newp; Point(cp2[4]) = {- .7,0,0.8, lc};
cp2[5] = newp; Point(cp2[5]) = {- .5,0,0.95, lc};
cp2[6] = newp; Point(cp2[6]) = {- .2,0,1.15, lc};
cp2[7] = p4;

cp3[0] = p6;
cp3[1] = newp; Point(cp3[1]) = {0, -1.0,0.2, lc};
cp3[2] = newp; Point(cp3[2]) = {0, - .9,0.45, lc};
cp3[3] = newp; Point(cp3[3]) = {0, - .8,0.7, lc};
cp3[4] = newp; Point(cp3[4]) = {0, - .7,0.8, lc};
cp3[5] = newp; Point(cp3[5]) = {0, - .5,0.95, lc};
cp3[6] = newp; Point(cp3[6]) = {0, - .2,1.15, lc};
cp3[7] = p4;

cp4[0] = p10;
cp4[1] = newp; Point(cp4[1]) = {r*Cos(t),0,r*Sin(t)+0.1, lc};
cp4[2] = newp; Point(cp4[2]) = { .9,0,0.45, lc};
cp4[3] = newp; Point(cp4[3]) = { .8,0,0.7, lc};
cp4[4] = newp; Point(cp4[4]) = { .7,0,0.8, lc};
cp4[5] = newp; Point(cp4[5]) = { .5,0,0.95, lc};
cp4[6] = newp; Point(cp4[6]) = { .2,0,1.15, lc};
cp4[7] = p4;

c1 = newreg; Circle(c1)   = {p11,p1,p7}; c2 = newreg; Circle(c2)  = {p7,p1,p5};
c3 = newreg; BSpline(c3)  = {cp2[]};     c4 = newreg; BSpline(c4) = {cp4[]};
c5 = newreg; Circle(c5)   = {p8,p1,p3};  c6 = newreg; Circle(c6)  = {p3,p1,p5};
c7 = newreg; Circle(c7)   = {p5,p1,p6};  c8 = newreg; Circle(c8)  = {p6,p1,p9};
c9 = newreg; Circle(c9)   = {p7,p1,p3}; c10 = newreg; BSpline(c10) = {cp1[]};
c11 = newreg; BSpline(c11)= {cp3[]};    c12 = newreg; Circle(c12) = {p6,p1,p7};
c13 = newreg; Circle(c13) = {p8,p12,p10}; c14 = newreg; Circle(c14) = {p10,p12,p9};
c15 = newreg; Circle(c15) = {p9,p12,p11}; c16 = newreg; Circle(c16) = {p11,p12,p8};

l1 = newreg; Line Loop(l1) = {c5,c10,-c4,-c13};   s1 = newreg; Ruled Surface(s1) = {l1};
l2 = newreg; Line Loop(l2) = {c9,-c5,-c16,c1};   s2 = newreg; Ruled Surface(s2) = {l2};
l3 = newreg; Line Loop(l3) = {c12,-c1,-c15,-c8}; s3 = newreg; Ruled Surface(s3) = {l3};
l4 = newreg; Line Loop(l4) = {c8,-c14,c4,-c11};  s4 = newreg; Ruled Surface(s4) = {l4};
l5 = newreg; Line Loop(l5) = {-c10,c6,c3};       s5 = newreg; Ruled Surface(s5) = {l5};
l6 = newreg; Line Loop(l6) = {c11,-c3,c7};      s6 = newreg; Ruled Surface(s6) = {l6};
l7 = newreg; Line Loop(l7) = {-c2,-c7,-c12};     s7 = newreg; Ruled Surface(s7) = {l7};
l8 = newreg; Line Loop(l8) = {-c6,-c9,c2};       s8 = newreg; Ruled Surface(s8) = {l8};
l9 = newreg; Line Loop(l9) = {c13,c14,c15,c16};  s9 = newreg; Plane Surface(s9) = {l9};

// extrude pen part into the apple
s_in[] = Extrude{-L,0,0} {
  Surface{s9}; 
};

// extrude pen part out of the apple
s_out[] = Extrude{2*L,0,0} {
  Surface{s9}; 
};

// make the tip of the pen (picked up numbers from the GUI)
tip = Translate{ -0.2, 0,0} { Duplicata{ Point{37}; } };
ct1 = newreg; Line(ct1) = {38,tip};
ct2 = newreg; Line(ct2) = {36,tip};
ct3 = newreg; Line(ct3) = {48,tip};
ct4 = newreg; Line(ct4) = {43,tip};
lt1 = newreg; Line Loop(lt1) = {-ct1,37,ct4};
lt2 = newreg; Line Loop(lt2) = {-ct4,38,ct3};
lt3 = newreg; Line Loop(lt3) = {-ct3,39,ct2};
lt4 = newreg; Line Loop(lt4) = {-ct2,36,ct1};
stip[0] = newreg; Ruled Surface(stip[0]) = {lt1};
stip[1] = newreg; Ruled Surface(stip[1]) = {lt2};
stip[2] = newreg; Ruled Surface(stip[2]) = {lt3};
stip[3] = newreg; Ruled Surface(stip[3]) = {lt4};

vtip   = newreg; Surface Loop(vtip) = {stip[], s_in[0]};
voltip = newreg; Volume(voltip) = {vtip};

// debugging print (to interpret the output from Extrude commands)
Printf("s_in = '%g'", s_in[0]);
Printf("s1 = '%g'", s_in[1]);
Printf("s2 = '%g'", s_in[2]);
Printf("s3 = '%g'", s_in[3]);
Printf("s4 = '%g'", s_in[4]);
Printf("s5 = '%g'", s_in[5]);

Surface Loop(300) = {stip[],s_in[2],s_in[3],s_in[4],s_in[5], s1,s2,s3,s4,s5,s6,s7,s8};
Volume(1337) = {300};

Physical Volume("Apple")     = {1337};
Physical Volume("Pen")       = {s_in[1], s_out[1], voltip};
Physical Surface("OutPen")   = {s_out[0], s_out[2], s_out[3], s_out[4], s_out[5]};
Physical Surface("OutApple") = {300};
